<template>
  <v-app id="inspire">
    <v-main>
      <v-container
        fluid
      >
        <v-row
          align="start"
          justify="center"
        >
          <v-col
            cols="12"
            sm="12"
            md="12"
          >
            <v-form ref="form" v-model="valid" lazy-validation class="mb-10">
              <v-text-field
                v-model="title"
                :rules="titleRules"
                label="Заголовок"
                type="text"
                required
              />

              <v-textarea
                v-model="text"
                :rules="textRules"
                autocomplete="Текст"
                label="Текст"
                required
              />

              <v-file-input
                v-model="chosenFile"
                :rules="[chosenFileRules, checkFileFormat, checkFileSize]"
                label="Добавить миниатюру"
                required
                @change="handleFileUpload"
              />
            </v-form>
            <v-btn color="success" large :disabled="!valid" @click="validate">
              Добавить
            </v-btn>
          </v-col>
        </v-row>
      </v-container>
    </v-main>
  </v-app>
</template>

<script>
export default {
  data: () => ({
    valid: false,
    title: '',
    titleRules: [
      v => !!v || 'Поле обязательно для заполнения',
      v => (v || '').length >= 2 || 'Заголовок должен содержать не менее 2 символов',
      v => (v || '').length <= 100 || 'Заголовок должен содержать не более 100 символов'
    ],
    text: '',
    textRules: [
      v => !!v || 'Поле обязательно для заполнения',
      v => (v || '').length >= 20 || 'Содержимое статьи должно содержать не менее 20 символов',
      v => (v || '').length <= 1000 || 'Заголовок должен содержать не более 500 символов'
    ],
    chosenFile: null,
    chosenFileRules: v => !!v || 'Поле обязательно для заполнения',
    formData: new FormData()
  }),

  methods: {
    checkFileFormat (file) {
      let isImage = false

      if (file) {
        isImage = (file.type === 'image/jpeg') || (file.type === 'image/jpg') || (file.type === 'image/png')
      }

      return isImage || 'Изображение должно быть в формате JPEG или PNG'
    },
    checkFileSize (file) {
      const maxSize = 5242880
      let isTrueSize = false

      if (file) {
        isTrueSize = file.size <= maxSize
      }

      return isTrueSize || 'Размер изображения не должен превышать 5 Мб'
    },
    handleFileUpload () {
      this.formData.append('image', this.chosenFile)
    },
    validate () {
      if (this.$refs.form.validate()) {
        this.formData.append('title', this.title)
        this.formData.append('text', this.text)

        this.addPost()
      }
    },
    async addPost () {
      try {
        await this.$axios.post('post', this.formData, {
          headers: { 'Content-Type': 'multipart/form-data' }
        })

        this.$refs.form.reset()
        this.$router.push('/')
      } catch (e) {
        // this.error = e.response.data.error
      }
    }
  },

  head () {
    return {
      title: 'Добавить статью',
      meta: [
        {
          hid: 'Добавить статью',
          name: 'Добавить статью',
          content: 'Добавить статью'
        }
      ]
    }
  }
}
</script>
